Page MenuHomePhabricator

Add a "create a page" interface to MediaWiki core
Open, LowestPublic

Description

The current system for adding pages to a MediaWiki wiki is completely unintuitive. When trying to explain it to people, they get completely confused about why there isn't simply a "create a page" link in the sidebar (or wherever) that can be clicked to start a new page. When I have to explain that you must go through Special:Search or type the title directly into the URL bar or create a link first, people look at me like I'm insane. And in some ways, this model is insane.

MediaWiki needs a functionality similar to that of WordPress where pages can be created by mortals easily. I'm told this might require some reworking of the EditPage.php code, as not having a title already when trying to create a page is currently problematic. That said, I believe this is a very serious user interface issue that should be resolved and it is certainly not impossible to resolve this issue properly.

See Also:

Details

Reference
bz27311

Event Timeline

bzimport raised the priority of this task from to Lowest.Nov 21 2014, 11:23 PM
bzimport set Reference to bz27311.
bzimport added a subscriber: Unknown Object (MLST).
  • Bug 29375 has been marked as a duplicate of this bug. ***
Krinkle added a comment.EditedMay 11 2012, 5:49 PM

I recall Siebrand once working on something like this. At least he showed it to me once during a Hackathon. If I recall correctly it was reverted from trunk a few years ago for a minor problem.

(In reply to comment #2)

I recall Siebrand one working on something like this. At least he showed it to
me once during a Hackathon. If I recall correctly it was reverted from trunk a
few years ago for a minor problem.

Probably makes sense to dig this out and figure out what went wrong. MediaWiki really ought to have this feature.

-easy: no clear task defined yet.

Qgil added a comment.Mar 7 2013, 4:54 PM

I can see plenty of Wikimedia and other MediaWiki users happy with this
feature.

It would be good to know whether there is a buy in from the Core maintainers or
whether they think this should be handled by an extension. A rough idea of the
estimated work would be useful too. It sounds like a potential candidate for
http://www.mediawiki.org/wiki/Mentorship_programs/Possible_projects

PS: found thanks to
https://www.mediawiki.org/wiki/Bug_management/Triage/20130307

A create a page interface would be really good. Though a proper core quality one may not be all to simple when you consider some other factors.

The editor interface has lots of special cases that vary by title.

  • Warnings and messages that only show up in specific namespaces. Many customized by wikis for page creation warnings.
  • Special editors available for .js/.css ending pages, namespaces like Module:, etc...

So it's tricky to have the editor interface alongside the title input when things can vary so much by title.

swalling wrote:

(In reply to comment #5)

I can see plenty of Wikimedia and other MediaWiki users happy with this
feature.

It would be good to know whether there is a buy in from the Core maintainers
or
whether they think this should be handled by an extension. A rough idea of
the
estimated work would be useful too. It sounds like a potential candidate for
http://www.mediawiki.org/wiki/Mentorship_programs/Possible_projects

PS: found thanks to
https://www.mediawiki.org/wiki/Bug_management/Triage/20130307

Rough estimate of work involved: very high.

This is a pretty complicated workflow issue with a lot of stakeholders in the community. It's really not a general MediaWiki issue with a one size fits all solution that can be deployed to the cluster.

For reference, the product team has been thinking about this area for some time now: https://www.mediawiki.org/wiki/Article_creation_workflow

(In reply to comment #8)

Rough estimate of work involved: very high.

Well, sure, it's possible to make any project overly complicated. Sometimes there's a distinct advantage to doing so.

In this case, however, I don't think it's a particularly involved project.

https://www.mediawiki.org/wiki/Article_creation_workflow

Most of this isn't really relevant here. Again, yes, it's certainly possible to set up user tests and queues and solicit user feedback via large smiley faces and do all kinds of craziness, but that isn't what's being requested here. If the Wikimedia Foundation wants to pursue all of that, that's its prerogative, of course.

For MediaWiki core, it isn't unreasonable to assume that there be a Special:CreatePage interface that accepts a title input and a textarea input. There are a few complicating details, as Daniel mentioned in comment 6, but even those are mostly trivially solvable. You can either ask for a title before getting started or you can simply provide a warning-free textarea (and only warn post-attempted save).

I envision something like Special:CreatePage with a title and textarea, a second "Review your new page" page (with suggestions like adding wikilinks to build the web, and a final submission page.

Honestly, there's little that could be done to make the page creation process worse than it already is. Nearly anything would be an improvement.

Qgil added a comment.Mar 9 2013, 5:36 AM

This is an enhancement request for MediaWiki, not for Wikipedia.

The request is quite simple: a basic UI to create new articles. Yes, many things can go wrong but just as many as typing the title of a new article in the URL field of the browser or as link in an existing page, as people do today.

https://www.mediawiki.org/wiki/Extension:Create_Page seemed to have this exact aim. There is code developed by Jeroen and paid by the WMF that allegedly runs on 1.18 and higher. It looks like a solution or at least a starting point.

As we can see from the URL pointed by Steven, the WMF is not interested in developing a(nother) quick fix but, if anything, in having a whole study on the article creation process. The MediaWiki maintainers haven't touched this request in two years and thay keep having other priorities now.

For all these reasons it seems obvious that this is a WONTFIX as a MediaWiki core feature. If a MediaWiki project needs this feature then CratePage is the first place to look at.

I don't have an opinion on the closure, but

(In reply to comment #10)

https://www.mediawiki.org/wiki/Extension:Create_Page seemed to have this
exact
aim. There is code developed by Jeroen and paid by the WMF that allegedly
runs
on 1.18 and higher. It looks like a solution or at least a starting point.

from the description of that extension I would never ever have guessed that it does something similar to what asked on this bug (it's presented as an InputBox alternative): as you seem to know more than most people about that extension, could you please improve the page?
Thanks.

This extension is indeed an InputBox [0] alternative. It's both simpler and less powerful. Perhaps more importantly, InputBox is already in use by WMF, so if you want such a solution, that one seems like the most logical pick.

[0] https://www.mediawiki.org/wiki/Extension:InputBox

(In reply to comment #10)

This is an enhancement request for MediaWiki, not for Wikipedia.

Right.

As we can see from the URL pointed by Steven, the WMF is not interested in
developing a(nother) quick fix but, if anything, in having a whole study on
the article creation process. The MediaWiki maintainers haven't touched this
request in two years and thay keep having other priorities now.

MediaWiki maintainers having other priorities is not a valid reason to mark a bug as resolved/wontfix. I've stated this in many places, many times, but I'll do it again here: wontfix means "we're never, ever going to fix this bug, to the point of not even accepting a patch for it, so stop asking." That clearly doesn't apply here.

For all these reasons it seems obvious that this is a WONTFIX as a MediaWiki
core feature. If a MediaWiki project needs this feature then CratePage is the
first place to look at.

No.

(In reply to comment #9)

I envision something like Special:CreatePage with a title and textarea, a
second "Review your new page" page (with suggestions like adding wikilinks to
build the web, and a final submission page.

Honestly, there's little that could be done to make the page creation process
worse than it already is. Nearly anything would be an improvement.

I'm beginning to wonder if VisualEditor would cover this bug. Though it still wouldn't be a core interface... hrm.

swalling wrote:

(In reply to comment #14)

I'm beginning to wonder if VisualEditor would cover this bug. Though it still
wouldn't be a core interface... hrm.

I don't think it does. VE is a big step forward in removing markup as a barrier, but if you start a page... it's still just a blank page to write in. Plus, the flows in to page creation are still the same: search for it, type in the URL directly, or click a red link.

TheDJ updated the task description. (Show Details)Dec 22 2015, 9:51 AM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptDec 22 2015, 9:51 AM
Qgil removed a subscriber: Qgil.Dec 22 2015, 5:50 PM

@MZMcBride Glad to see some interest in the Wizard. Here's current status: FormWizard works, and is fairly configurable, but it's currently unmaintained. There are also some potential security issues (T129058) that stem from workarounds we put in place to make nice with Extension:Translate. A couple more bugs and tasks are logged at FormWizard. I'm happy to improve doc or answer questions. @Jephpaul, who wrote the code, is still active in the community but seldom on Phab.

FormWizard is used in the IdeaLab and several of the Grants programs. Also, I believe @Harej has adapted FormWizard for use on Enwiki for WikiProject-X.

Anyway, like I said, happy to help maintain the project any way I can, if someone has new use-cases or wants to set a roadmap.

Harej added a comment.Aug 29 2016, 5:16 PM

Also, I believe @Harej has adapted FormWizard for use on Enwiki for WikiProject-X.

FormWizard was imported to English Wikipedia for use on the Co-Op, now defunct. It has been significantly used by WikiProject X, namely for a dozen or so WikiProjects for member workflows. The annoying thing is that a form has to be created for each individual WikiProject, meaning that you need to be an admin to set it up (because you have to create pages in the MediaWiki namespace). It also works by creating member profiles as individual pages that are then transcluded, instead of just making edits to a central list. This results in the proliferation of user-space pages that would be better to avoid.

The CollaborationKit extension will replace FormWizard use for these WikiProjects through its built-in membership workflows. In the general case though, I do think we should have better interfaces for designing and deploying forms on wiki sites.

Krinkle removed a subscriber: Krinkle.
Harej awarded a token.Jan 28 2017, 1:29 AM

This might be worthy of mention: I have been able to translate https://meta.wikimedia.org/wiki/Meta:FormWizard/Config/Rapid and https://meta.wikimedia.org/wiki/Meta:AddMe/Config today. This was not possible before due to a restriction on creation of new pages under "Meta:" root.

@Haythamabulela I'm glad to hear that! You can thank @Tgr for the fix. See T129058#2985023 and let us know (and maybe @I_JethroBT too) if you encounter any additional errors.

I love the idea of this module. I'm trying to get Template:WPX_member_box functional in WikiProject_Molecular_Biology. It seems to work fine in other wikiprojects. Is there page that I need to create that I'm missing?